﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Data;
using System.Diagnostics;
using System.ComponentModel;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        private VirtualQueryableCollectionView groups;
        public VirtualQueryableCollectionView Groups
        {
            get
            {
                if (groups == null)
                {
                    groups = new VirtualQueryableCollectionView();
                    groups.ItemsLoading += HandleItemsLoading;
                    groups.LoadSize = 20;

                    // by assigning a value to VirtualItemCount property, we can force the ItemsLoading
                    // event to fire
                    groups.VirtualItemCount = 10000;
                }

                return groups;
            }
            private set
            {
                if (groups != value)
                {
                    groups.ItemsLoading -= HandleItemsLoading;
                    groups = value;

                    if (PropertyChanged != null)
                    {
                        PropertyChanged(this, new PropertyChangedEventArgs("Groups"));
                    }
                }
            }
        }

        public MainPage()
        {
            InitializeComponent();

            DataContext = this;
        }

        private int startIndex;
        private string[] ar;

        // simulation of slow service by right click
        protected override void OnMouseRightButtonDown(System.Windows.Input.MouseButtonEventArgs e)
        {
            base.OnMouseRightButtonDown(e);

            // simulation of delayed service callback
            Debug.WriteLine(string.Format("---- Writting {0} count {1}", startIndex, ar.Length));
            groups.Load(startIndex, ar);

            /*
            if((startIndex / groups.PageSize) != groups.PageIndex)
            {
               groups.NeedsRefresh = true;
            }
            */
        }

        private void HandleItemsLoading(object sender, VirtualQueryableCollectionViewItemsLoadingEventArgs e)
        {
            Debug.WriteLine(string.Format("Asking from {0} count {1}", e.StartIndex, e.ItemCount));

            // groups.Load(e.StartIndex, ar);
            // do not load it now, load it later after async call (right click in this demo).

            ar = new string[e.ItemCount];
            for (int i = 0; i < e.ItemCount; i++)
            {
                ar[i] = "s" + i;
            }
            startIndex = e.StartIndex;

            Groups.Load(e.StartIndex, from i in Enumerable.Range(e.StartIndex, e.ItemCount) select i);
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
